﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BLSpaceRay.Math3D;

namespace BLSpaceRay.Scene.Lighting
{
    public class LightPoint : Light
    {

        #region " Constructors "

        public LightPoint()
        {
            // Set the default values
            m_Position = new Vector3();
            m_Color = new Colorf();
            m_Shadowed = false;
        }
        public LightPoint(Vector3 pos, Colorf col, float cons, float line, float quad, bool shadowed)
        {
            // Set the new values
            m_Position = pos;
            m_Color = col;
            m_Shadowed = shadowed;
            m_Constant = cons;
            m_Linear = line;
            m_Quadratic = quad;
        }

        #endregion

        #region " Methods "

        public void Set(Vector3 pos, Colorf col, float cons, float line, float quad, bool shadowed)
        {
            // Set the new values
            m_Position = pos;
            m_Color = col;
            m_Shadowed = shadowed;
            m_Constant = cons;
            m_Linear = line;
            m_Quadratic = quad;
        }

        #endregion

        #region " Overrides "

        public override int GetKind()
        {
            return 1;
        }

        #endregion
    }
}
