﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BLSpaceRay.Math3D;

namespace BLSpaceRay.Scene.Lighting
{
    public class LightSpot : Light
    {
         #region " Constructors "

        public LightSpot()
        {
            // Set the default values
            m_Position = new Vector3();
            m_Color = new Colorf();
            m_Shadowed = false;
        }
        public LightSpot(Vector3 pos, Vector3 dir, Colorf col, float cons, float line, float quad, float pow, bool shadowed)
        {
            // Set the new values
            m_Direction = dir;
            m_Position = pos;
            m_Color = col;
            m_Shadowed = shadowed;
            m_Constant = cons;
            m_Linear = line;
            m_Quadratic = quad;
            m_POW = pow;
        }

        #endregion

        #region " Methods "

        public void Set(Vector3 pos, Vector3 dir, Colorf col, float cons, float line, float quad, float pow, bool shadowed)
        {
            // Set the new values
            m_Direction = dir;
            m_Position = pos;
            m_Color = col;
            m_Shadowed = shadowed;
            m_Constant = cons;
            m_Linear = line;
            m_Quadratic = quad;
            m_POW = pow;
        }

        #endregion

        #region " Overrides "

        public override int GetKind()
        {
            return 2;
        }

        #endregion
    }
}
